# NOTE: Derived from blib/lib/URI/Bookmarks/Netscape.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package URI::Bookmarks::Netscape;

#line 43 "blib/lib/URI/Bookmarks/Netscape.pm (autosplit into blib/lib/auto/URI/Bookmarks/Netscape/import_bookmarks.al)"
sub import_bookmarks {
  my $self = shift;
  my %p = @_;

  my ($input_type, $source) = figure_out_input(\%p);
  
  my $current_folder = $self->tree_root;
  my $first = 1;
  my $in_DD = 0;
  my $in_preamble = 1;
  my ($last_folder, $last_bookmark);

  while ($_ = get_line($input_type, \%p)) {
    chomp;

    if (m{^\s*<DT><A (.*?)>(.*)</A>$}i) {
      my ($attribs, $bookmark) = ($1, $2);

      $in_DD = 0;
      undef $last_folder;

      my $new_bookmark = $current_folder->new_daughter;
      $new_bookmark->name($bookmark);
      $new_bookmark->type('bookmark');

      my @attribs = split /\s+/, $attribs;
      foreach my $attrib (@attribs) {
        if (my ($name, $value) = ($attrib =~ /^([^=]+)(?:="(.*)")?$/)) {
          $new_bookmark->set_attribs($name => $value);
        }
      }

      $last_bookmark = $new_bookmark;

      next;
    }

    if (m{^\s*<DT><H3 (.*?)>(.*)</H3>$}i) {
      my ($attribs, $folder) = ($1, $2);

      undef $last_bookmark;
      $in_DD = 0;

      my $new_folder = $current_folder->new_daughter;
      $new_folder->name($folder);
      $new_folder->type('folder');

      my @attribs = split /\s+/, $attribs;
      foreach my $attrib (@attribs) {
        if (my ($name, $value) = ($attrib =~ /^([^=]+)(?:="(.*)")?$/)) {
          $new_folder->set_attribs($name, $value);
        }
      }

      $last_folder = $new_folder;
      next;
    }

    if (m{^\s*<HR>$}i) {
      $in_DD = 0;
      undef $last_bookmark;
      undef $last_folder;

      my $rule = $current_folder->new_daughter;
      $rule->name('----------');
      $rule->type('rule');

      next;
    }

    if (m{^\s*<DL><p>$}i) {
      $in_DD = 0;
      $in_preamble = 1;

      if ($first) {
        $first = 0;
        next;
      }

      $current_folder = $last_folder;

      undef $last_bookmark;
      undef $last_folder;

      next;
    }

    if (m{^\s*</DL><p>$}i) {
      $in_DD = 0;
      undef $last_folder;
      undef $last_bookmark;

      $current_folder = $current_folder->mother;

      next;
    }

    if (m{^<DD>(.*)}i) {
      $in_DD = 1;

      my $last = $last_bookmark || $last_folder;
      # This should really call set_attribs to be properly OO but we
      # don't care too much.
      $last->attribute->{description} .= "$1\n";

      next;
    }      

    if ($in_DD) {
      my $last = $last_bookmark || $last_folder;
      # This should really call set_attribs to be properly OO but we
      # don't care too much.
      $last->attribute->{description} .= "$_\n";
      next;
    }

    if ($in_preamble) {
      if (m{^<!DOCTYPE (.+)>$}i) {
        $self->{origin}{doctype} = $1;
        next;
      }

      if (m{^<!-- This is an automatically generated file.$} ||
          m{^It will be read and overwritten.$} ||
          m{^Do Not Edit! -->$})
        {
          $self->{origin}{preamble} .= "$_\n";
          next;
        }

      if (m{^<TITLE>(.+)</TITLE>$}i) {
        $self->title($1);
        next;
      }
    
      if (m{^<H1>(.+)</H1>$}i) {
        $self->tree_root->name($1);
        next;
      }

      next if /^\s*$/;
    }

    warn "Ignoring line $line_num of $source:\n$_\n";
  }

  close(BOOKMARKS);

  $self->{origin}{type} = 'Netscape bookmarks file';
  $self->{origin}{source} = $source;
}

# end of URI::Bookmarks::Netscape::import_bookmarks
1;
